Apache Tomcat 7.0.42

## org.apache.tomcat.util.digester
Class SetTopRule

    java.lang.Object
      org.apache.tomcat.util.digester.Rule
          org.apache.tomcat.util.digester.SetTopRule

    public class SetTopRule

extends Rule

Rule implementation that calls a "set parent" method on the top (child) object, passing the (top-1) (parent) object as an argument.

This rule now supports more flexible method matching by default. It is possible that this may break (some) code written against release 1.1.1 or earlier. See `isExactMatch()` for more details.

Field Summary
`protected String` `methodName` The method name to call on the child object.
`protected String` `paramType` The Java class name of the parameter type expected by the method.
`protected boolean` `useExactMatch` Should we use exact matching.

Fields inherited from class org.apache.tomcat.util.digester.Rule
`digester, namespaceURI`

Constructor Summary
`SetTopRule(Digester digester, String methodName)` Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetTopRule(String methodName)` instead.
`SetTopRule(Digester digester, String methodName, String paramType)` Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetTopRule(String methodName, String paramType)` instead.
`SetTopRule(String methodName)` Construct a "set parent" rule with the specified method name.
`SetTopRule(String methodName, String paramType)` Construct a "set parent" rule with the specified method name.

Method Summary
`void` `end(String namespace, String name)` Process the end of this element.
`boolean` `isExactMatch()` Is exact matching being used.
`void` `setExactMatch(boolean useExactMatch)` Set whether exact matching is enabled.
`String` `toString()` Render a printable version of this Rule.

Methods inherited from class org.apache.tomcat.util.digester.Rule
`begin, begin, body, body, end, finish, getDigester, getNamespaceURI, setDigester, setNamespaceURI`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### methodName

    protected String methodName

  The method name to call on the child object.

### paramType

    protected String paramType

  The Java class name of the parameter type expected by the method.

### useExactMatch

    protected boolean useExactMatch

  Should we use exact matching. Default is no.

Constructor Detail

### SetTopRule

    @Deprecated
    public SetTopRule(Digester digester,
                                 String methodName)

  Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetTopRule(String methodName)` instead.

  Construct a "set parent" rule with the specified method name. The "set parent" method's argument type is assumed to be the class of the parent object.

  Parameters:
    `digester` - The associated Digester
    `methodName` - Method name of the "set parent" method to call

### SetTopRule

    @Deprecated
    public SetTopRule(Digester digester,
                                 String methodName,
                                 String paramType)

  Deprecated. The digester instance is now set in the `Digester.addRule(java.lang.String, org.apache.tomcat.util.digester.Rule)` method. Use `SetTopRule(String methodName, String paramType)` instead.

  Construct a "set parent" rule with the specified method name.

  Parameters:
    `digester` - The associated Digester
    `methodName` - Method name of the "set parent" method to call
    `paramType` - Java class of the "set parent" method's argument (if you wish to use a primitive type, specify the corresponding Java wrapper class instead, such as `java.lang.Boolean` for a `boolean` parameter)

### SetTopRule

    public SetTopRule(String methodName)

  Construct a "set parent" rule with the specified method name. The "set parent" method's argument type is assumed to be the class of the parent object.

  Parameters:
    `methodName` - Method name of the "set parent" method to call

### SetTopRule

    public SetTopRule(String methodName,
                      String paramType)

  Construct a "set parent" rule with the specified method name.

  Parameters:
    `methodName` - Method name of the "set parent" method to call
    `paramType` - Java class of the "set parent" method's argument (if you wish to use a primitive type, specify the corresponding Java wrapper class instead, such as `java.lang.Boolean` for a `boolean` parameter)

Method Detail

### isExactMatch

    public boolean isExactMatch()

  Is exact matching being used.

  This rule uses `org.apache.commons.beanutils.MethodUtils` to introspect the relevant objects so that the right method can be called. Originally, `MethodUtils.invokeExactMethod` was used. This matches methods very strictly and so may not find a matching method when one exists. This is still the behaviour when exact matching is enabled.

  When exact matching is disabled, `MethodUtils.invokeMethod` is used. This method finds more methods but is less precise when there are several methods with correct signatures. So, if you want to choose an exact signature you might need to enable this property.

  The default setting is to disable exact matches.

  Returns:
    true iff exact matching is enabled
  Since:
    Digester Release 1.1.1

### setExactMatch

    public void setExactMatch(boolean useExactMatch)

  Set whether exact matching is enabled.

  See `isExactMatch()`.

  Parameters:
    `useExactMatch` - should this rule use exact method matching
  Since:
    Digester Release 1.1.1

### end

    public void end(String namespace,
                    String name)
             throws Exception

  Process the end of this element.

  Overrides:
    `end` in class `Rule`
  Parameters:
    `namespace` - the namespace URI of the matching element, or an empty string if the parser is not namespace aware or the element has no namespace
    `name` - the local name if the parser is namespace aware, or just the element name otherwise
  Throws:
    `Exception`

### toString

    public String toString()

  Render a printable version of this Rule.

  Overrides:
    `toString` in class `Object`

Apache Tomcat 7.0.42

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.